// -*- C++ -*-
//
// $Id: Echo_Client_ORBInitializer.cpp 76591 2007-01-25 18:17:52Z elliott_c $

#include "Echo_Client_ORBInitializer.h"

ACE_RCSID (Dynamic, Echo_Client_ORBInitializer, "$Id: Echo_Client_ORBInitializer.cpp 76591 2007-01-25 18:17:52Z elliott_c $")

#if TAO_HAS_INTERCEPTORS == 1

#include "client_interceptor.h"

void
Echo_Client_ORBInitializer::pre_init (
    PortableInterceptor::ORBInitInfo_ptr)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
}

void
Echo_Client_ORBInitializer::post_init (
    PortableInterceptor::ORBInitInfo_ptr info)
  ACE_THROW_SPEC ((CORBA::SystemException))
{

  PortableInterceptor::ClientRequestInterceptor_ptr interceptor =
    PortableInterceptor::ClientRequestInterceptor::_nil ();

  // Install the Echo client request interceptor
  ACE_NEW_THROW_EX (interceptor,
                    Echo_Client_Request_Interceptor,
                    CORBA::NO_MEMORY ());

  PortableInterceptor::ClientRequestInterceptor_var
    client_interceptor = interceptor;

  info->add_client_request_interceptor (client_interceptor.in ());

}

#endif  /* TAO_HAS_INTERCEPTORS == 1 */
